diff -ruN ../nakedmudv3.3/src/time/time.c src/time/time.c
--- ../nakedmudv3.3/src/time/time.c	2006-12-24 22:15:56.000000000 -0500
+++ src/time/time.c	2007-09-22 22:36:11.000000000 -0400
@@ -6,8 +6,7 @@
 //
 //*****************************************************************************
 
-#include <Python.h>        // to add nightdesc
-#include <structmember.h>
+#include <Python.h>        // to add Python hooks
 
 #include "../mud.h"
 #include "../utils.h"
@@ -91,107 +90,6 @@
 
 
 //*****************************************************************************
-//
-// auxiliary data
-//
-// the time module gives rooms the ability to have different day and night
-// descriptions. Below are the functions required for installing this.
-//
-//*****************************************************************************
-typedef struct time_aux_data {
-  BUFFER *night_desc;        // our description at night time
-} TIME_AUX_DATA;
-
-TIME_AUX_DATA *
-newTimeAuxData() {
-  TIME_AUX_DATA *data = malloc(sizeof(TIME_AUX_DATA));
-  data->night_desc = newBuffer(1);
-  return data;
-}
-
-void
-deleteTimeAuxData(TIME_AUX_DATA *data) {
-  if(data->night_desc) deleteBuffer(data->night_desc);
-  free(data);
-}
-
-void
-timeAuxDataCopyTo(TIME_AUX_DATA *from, TIME_AUX_DATA *to) {
-  bufferCopyTo(from->night_desc, to->night_desc);
-}
-
-TIME_AUX_DATA *
-timeAuxDataCopy(TIME_AUX_DATA *data) {
-  TIME_AUX_DATA *newdata = newTimeAuxData();
-  timeAuxDataCopyTo(data, newdata);
-  return newdata;
-}
-
-STORAGE_SET *timeAuxDataStore(TIME_AUX_DATA *data) {
-  STORAGE_SET *set = new_storage_set();
-  store_string(set, "night_desc", bufferString(data->night_desc));
-  return set;
-}
-
-TIME_AUX_DATA *timeAuxDataRead(STORAGE_SET *set) {
-  TIME_AUX_DATA *data = newTimeAuxData();
-  bufferCat(data->night_desc, read_string(set, "night_desc"));
-  return data;
-}
-
-const char *roomGetNightDesc(ROOM_DATA *room) {
-  TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
-  return bufferString(data->night_desc);
-}
-
-BUFFER *roomGetNightDescBuffer(ROOM_DATA *room) {
-  TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
-  return data->night_desc;
-}
-
-void roomSetNightDesc(ROOM_DATA *room, const char *desc) {
-  TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
-  bufferClear(data->night_desc);
-  bufferCat(data->night_desc, (desc ? desc : ""));
-}
-
-
-
-//*****************************************************************************
-// Python getters and setters
-//*****************************************************************************
-PyObject *PyRoom_getndesc(PyObject *self, void *closure) {
-  ROOM_DATA *room = PyRoom_AsRoom(self);
-  if(room != NULL)  return Py_BuildValue("s", roomGetNightDesc(room));
-  else              return NULL;
-}
-
-int PyRoom_setndesc(PyObject *self, PyObject *value, void *closure) {
-  if (value == NULL) {
-    PyErr_Format(PyExc_TypeError, "Cannot delete room's night desc");
-    return -1;
-  }
-  
-  if (!PyString_Check(value)) {
-    PyErr_Format(PyExc_TypeError, 
-                    "Room night descs must be strings");
-    return -1;
-  }
-
-  ROOM_DATA *room = PyRoom_AsRoom(self);
-  if(room == NULL) {
-    PyErr_Format(PyExc_TypeError,
-		 "Tried to modify nonexistent room, %d", PyRoom_AsUid(self));
-    return -1;                                                                
-  }
-
-  roomSetNightDesc(room, PyString_AsString(value));
-  return 0;
-}
-
-
-
-//*****************************************************************************
 // Python methods
 //*****************************************************************************
 PyObject *PyMud_GetHour(PyObject *self) {
@@ -221,22 +119,6 @@
 //*****************************************************************************
 
 //
-// If it's in the night, swap out our desc for the room's night desc
-void room_nightdesc_hook(const char *info) {
-  ROOM_DATA   *room = NULL;
-  CHAR_DATA *looker = NULL;
-  hookParseInfo(info, &room, &looker);
-
-  if((is_evening() || is_night()) && *roomGetNightDesc(room)) {
-    // if it's the room desc and not an edesc, cat the night desc...
-    if(!strcasecmp(bufferString(charGetLookBuffer(looker)),roomGetDesc(room))) {
-      bufferClear(charGetLookBuffer(looker));
-      bufferCat(charGetLookBuffer(looker), roomGetNightDesc(room));
-    }
-  }
-}
-
-//
 // Handle the hourly update of our times
 //
 void handle_time_update(void *self, void *data, char *arg) {
@@ -297,39 +179,19 @@
   else
     curr_hour = curr_day_of_week = curr_day_of_month = curr_month = curr_year = 0;
 
-  // add a nightdesc get-setter to rooms
-  PyRoom_addGetSetter("ndesc", PyRoom_getndesc, PyRoom_setndesc,
-		      "the room's night desc");
-  PyRoom_addGetSetter("night_desc", PyRoom_getndesc, PyRoom_setndesc,
-		      "the room's night desc");
-
   // add our mud methods
   PyMud_addMethod("get_hour",     PyMud_GetHour,     METH_NOARGS, NULL);
   PyMud_addMethod("is_morning",   PyMud_IsMorning,   METH_NOARGS, NULL);
   PyMud_addMethod("is_afternoon", PyMud_IsAfternoon, METH_NOARGS, NULL);
   PyMud_addMethod("is_evening",   PyMud_IsEvening,   METH_NOARGS, NULL);
   PyMud_addMethod("is_night",     PyMud_IsNight,     METH_NOARGS, NULL);
-  
-  // add our set fields
-#ifdef MODULE_SET_VAL
-  add_set("ndesc",      SET_ROOM, SET_TYPE_STRING, roomSetNightDesc, NULL);
-  add_set("night_desc", SET_ROOM, SET_TYPE_STRING, roomSetNightDesc, NULL);
-#endif
 
   // add the time command
   add_cmd("time", NULL, cmd_time, POS_SITTING,  POS_FLYING,
 	  "player", TRUE, FALSE);
 
-  // add night descriptions for rooms
-  auxiliariesInstall("time_aux_data",
-		     newAuxiliaryFuncs(AUXILIARY_TYPE_ROOM,
-				       newTimeAuxData, deleteTimeAuxData,
-				       timeAuxDataCopyTo, timeAuxDataCopy,
-				       timeAuxDataStore, timeAuxDataRead));
-
   // start our time updater
   start_update(NULL, TIME_UPDATE_DELAY, handle_time_update, NULL, NULL, NULL);
-  hookAdd("preprocess_room_desc", room_nightdesc_hook);
 }
 
 
diff -ruN ../nakedmudv3.3/lib/pymodules/account_handler.py lib/pymodules/account_handler.py
--- ../nakedmudv3.3/lib/pymodules/account_handler.py	2006-12-24 22:31:26.000000000 -0500
+++ lib/pymodules/account_handler.py	2007-09-22 22:36:20.000000000 -0400
@@ -52,7 +52,7 @@
 def acct_name_handler(sock, arg):
     '''the first prompt a socket encounters; enter a name of an account or
        a new name of an account to create one'''
-    if mudsys.account_exists(arg):
+    if arg and mudsys.account_exists(arg):
         # logging on to an already existing account
         mud.log_string("Account '" + arg + "' is trying to connect.")
         acct = mudsys.load_account(arg)
@@ -207,7 +207,10 @@
         sock.push_ih(acct_new_password_handler, acct_new_password_prompt)
         sock.push_ih(acct_password_handler, acct_password_prompt)
     elif arg == 'N':
-        hooks.run("create_character", hooks.build_info("sk", (sock,)))
+        if "player" in [x.strip() for x in mudsys.sys_getval("lockdown").split(",")]:
+            sock.send("New characters are not allowed to be created at this time.")
+        else:
+            hooks.run("create_character", hooks.build_info("sk", (sock,)))
     else:
         sock.send("Invalid choice!")
 
diff -ruN ../nakedmudv3.3/lib/pymodules/char_gen.py lib/pymodules/char_gen.py
--- ../nakedmudv3.3/lib/pymodules/char_gen.py	2006-12-24 22:31:26.000000000 -0500
+++ lib/pymodules/char_gen.py	2007-09-22 22:36:20.000000000 -0400
@@ -60,15 +60,15 @@
 
     # send them the motd
     sock.ch.page(mud.get_motd())
-
-    # put him in the starting room
-    sock.ch.room = mudsys.sys_getval("start_room")
     
-    # run the init_player hook
-    hooks.run("init_player", hooks.build_info("ch", (sock.ch,)))
-
     # register and save him to disk and to an account
     mudsys.do_register(sock.ch)
+
+    # make him exist in the game for functions to look him up
+    mudsys.try_enter_game(sock.ch)
+
+    # run the init_player hook
+    hooks.run("init_player", hooks.build_info("ch", (sock.ch,)))
     
     # attach him to his account and save the accoutn
     sock.account.add_char(sock.ch)
diff -ruN ../nakedmudv3.3/lib/pymodules/cmd_comm.py lib/pymodules/cmd_comm.py
--- ../nakedmudv3.3/lib/pymodules/cmd_comm.py	2006-12-25 21:37:11.000000000 -0500
+++ lib/pymodules/cmd_comm.py	2007-09-22 22:36:20.000000000 -0400
@@ -115,7 +115,7 @@
          emote does a little dance.
          emote A gunshot sounds, and $n is laying on the ground, dead.'''
     if arg == '':
-        ch.send("Emote we must, but emote what?")
+        ch.send(ch, "Emote we must, but emote what?")
     else:
         # see if a $n is within the argument ... if there is, let the person
         # put his or her name where it's wanted. Otherwise, tag it onto the
@@ -127,7 +127,7 @@
 def cmd_gemote(ch, cmd, arg):
     '''cmd_gemote is similar to emote, but it sends a global message'''
     if arg == '':
-        ch.send("Gemote we must, but gemote what?")
+        ch.send(ch, "Gemote we must, but gemote what?")
     else:
         # same as emote, but global
         if arg.find("$n") == -1:
diff -ruN ../nakedmudv3.3/lib/pymodules/path.py lib/pymodules/path.py
--- ../nakedmudv3.3/lib/pymodules/path.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/path.py	2007-09-22 22:36:20.000000000 -0400
@@ -0,0 +1,213 @@
+'''
+path.py
+
+Plugs into the routine module to allow for the easy construction of paths and
+path following.
+'''
+from mud import *
+from mudsys import add_cmd
+import mud, mudsys
+
+
+
+################################################################################
+# functions
+################################################################################
+def leads_to(frm, to):
+    '''returns whether from leads directly to to'''
+    for ex in frm.exnames:
+        if frm.exit(ex).dest is to:
+            return True
+    return False
+
+def shortest_path_bfs(frm, to, ignore_doors = False, ignore = None):
+    '''calculates the shortest path, but uses a breadth first search. More
+       efficient than depth-first seach for very short paths with lots of
+       branches or very large muds.'''
+    if frm == to:
+        return [frm]
+
+    rooms = []
+    depth = []
+
+    if ignore == None:
+        ignore = set()
+    ignore.add(frm)
+
+    # what is our highest depth
+    i = 1
+
+    # the index of the room our last depth started at
+    j = 0
+
+    # append ourself and our depth
+    rooms.append(frm)
+    depth.append(i)
+
+    # keep going until we find To, or we can't go any deeper
+    found = False
+    while not found:
+        prev_depth = rooms[j:]
+        for rm in prev_depth:
+            for ex in rm.exnames:
+                dest = rm.exit(ex).dest
+                if dest in ignore:
+                    continue
+                rooms.append(dest)
+                depth.append(i)
+                if dest is to:
+                    found = True
+                    break
+                ignore.add(rm)
+            if found:
+                break
+
+        i += 1
+        j += len(prev_depth)
+
+    # go backwards from our destination
+    rooms.reverse()
+    depth.reverse()
+
+    # first step, pull out our destination room
+    path = [to]
+
+    # pull out all other rooms on the shortest path
+    while len(rooms) > 0:
+        curr_depth = depth[0]
+        
+        # figure out which room in our current layer
+        # links to our previous room in the shortest path
+        for next in rooms:
+            if leads_to(next, path[len(path)-1]):
+                path.append(next)
+                break
+
+        # clear our last layer
+        i = 0
+        while i < len(depth) and depth[i] == curr_depth:
+            i += 1
+        rooms = rooms[i:]
+        depth = depth[i:]
+
+    # put it back in order
+    path.reverse()
+    return path
+
+def shortest_path_dfs(frm, to, ignore_doors = False, ignore = None):
+    '''returns the steps needed to take to go from one room to another. More
+       efficient than breadth-first search for very long paths with only a few
+       branches, or very small muds.'''
+    path = []
+
+    if ignore == None:
+        ignore = set()
+
+    # a list of rooms we ignore for tracking. Add ourself so we don't loop back
+    ignore.add(frm)
+
+    # if we're the target room, return an empty list
+    if frm is to:
+        return [frm]
+
+    # build the shortest path 
+    for ex in frm.exnames:
+        # check if it has a door, and if we ignore it
+        if frm.exit(ex).is_closed:
+            continue
+
+        # get the dest room. if there is none, skip this exit
+        next_room = frm.exit(ex).dest
+        
+        if next_room is None:
+            continue
+
+        # if we already know this is a dead end or a loopback, skip it
+        if next_room in ignore:
+            continue
+
+        next_path = shortest_path(next_room, to, ignore_doors, ignore)
+
+        # dead end
+        if len(next_path) == 0:
+            continue
+
+        # we found a path, append ourself
+        next_path.insert(0, frm)
+
+        # are we shorter than the previous one?
+        if len(path) == 0 or len(path) > len(next_path):
+            path = next_path
+
+    return path
+
+# set whether we are using bfs or dfs as our main pathing method
+shortest_path = shortest_path_bfs
+
+def path_to_dirs(path):
+    '''takes a path of rooms and converts it to directions'''
+
+    dirs = []
+    i    = 0
+    while i < len(path) - 1:
+        for ex in path[i].exnames:
+            if path[i].exit(ex).dest == path[i+1]:
+                dirs.append(ex)
+                break
+        i = i + 1
+
+    # return the directions we generated, if any
+    return dirs
+
+def build_patrol(rms, reverse = True):
+    '''builds a set of directions that need to be followed to do a patrol
+       between the rooms. If reverse is true, also supplies the directions
+       to loop back on itself'''
+    if reverse == True:
+        loopback = [x for x in rms]
+        loopback.reverse()
+        rms      = rms + loopback[1:]
+
+    path = []
+    i    = 0
+    while i < len(rms) - 1:
+        path = path + shortest_path(rms[i], rms[i+1])
+        i += 1
+    return path_to_dirs(path)
+
+def step(frm, to, ignore_doors = False):
+    '''returns the first step needed to take to go from one room to another'''
+    steps = shortest_path(frm, to, ignore_doors)
+    if steps == None or len(steps) <= 1:
+        return None
+    return path_to_dirs(steps)[0]
+
+
+
+################################################################################
+# commands
+################################################################################
+def cmd_path(ch, cmd, arg):
+    '''This is really just for purposes of testing to make sure the module
+       works properly'''
+    try:
+        tgt, = parse_args(ch, True, cmd, arg, "ch.world.noself")
+    except: return
+
+    path = build_patrol([ch.room, tgt.room])
+    if len(path) == 0:
+        ch.send("Path doesn't exist")
+    else:
+        ch.send(str(path))
+
+
+
+################################################################################
+# initialization
+################################################################################
+
+# add our commands
+add_cmd("path", None, cmd_path, "sitting", "flying", "admin", False, False)
+
+# mud initialization
+mud.build_patrol = build_patrol
diff -ruN ../nakedmudv3.3/lib/pymodules/routine.py lib/pymodules/routine.py
--- ../nakedmudv3.3/lib/pymodules/routine.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/routine.py	2007-09-22 22:36:20.000000000 -0400
@@ -0,0 +1,203 @@
+'''
+routine.py
+
+This is a module for setting up one-time or repeatable routines for mobs. This
+can include walking a path, forging a sword, singing verses of a song, or
+anything else. This was primarily meant to be for path-following, but I figured
+it was worth the time to generalize it out for more complex actions
+'''
+from mud import *
+from mudsys import add_cmd
+import mud, mudsys, auxiliary, storage, event
+
+
+
+################################################################################
+# defines
+################################################################################
+__dflt_routine_step_time__ = 10 # seconds between routine steps
+__global_routine_checks__  = []
+
+
+
+################################################################################
+# auxiliary data
+################################################################################
+class RoutineAuxData:
+    def __init__(self, set = None):
+        self.routine = None   # the routine we follow
+        self.repeat  = False  # after we finish it, do we repeat?
+        self.step    = None   # what step of the routine are we on
+        self.checks  = None   # what checks do we perform before each step
+
+    def copyTo(self, to):
+        if isinstance(self.routine, list):
+            to.routine = [x for x in self.routine]
+        else:
+            to.routine = None
+        if isinstance(self.checks, list):
+            to.checks = [x for x in self.checks]
+        else:
+            to.checks = None
+        to.repeat = self.repeat
+        to.step   = self.step
+
+    def copy(self):
+        newdata = RoutineAuxData()
+        self.copyTo(newdata)
+        return newdata
+
+    def store(self):
+        return storage.StorageSet()
+
+    def read(self, set):
+        return
+
+
+
+################################################################################
+# functions
+################################################################################
+def register_routine_check(check):
+    '''adds a routine check to the global list. Must be a function taking one
+       argument, which is the character doing the routine'''
+    __global_routine_checks__.append(check)
+
+def start_routine(ch):
+    '''starts a character routine event in motion'''
+    time = __dflt_routine_step_time__
+    aux  = ch.getAuxiliary("routine_data")
+    item = aux.routine[aux.step]
+    if isinstance(item, tuple):
+        time = item[0]
+    event.start_event(ch, time, routine_event)
+
+def set_routine(ch, routine, repeat = False, checks = None):
+    '''Sets a routine to a character. Routine steps can constain commands
+       (character strings), functions (one argument, ch), or tuples
+       (delay, string | function). If a tuple is not supplied, the default
+       step time is used'''
+    aux = ch.getAuxiliary("routine_data")
+    aux.checks  = None
+    if checks != None:
+        aux.checks  = [x for x in checks]
+    aux.repeat  = repeat
+    aux.routine = None
+    aux.step    = None
+    if routine != None:
+        aux.routine = [x for x in routine]
+        aux.step    = 0
+        start_routine(ch)
+
+def do_step(ch):
+    '''Performs the current step increments'''
+    aux  = ch.getAuxiliary("routine_data")
+    step = aux.routine[aux.step]
+    time = __dflt_routine_step_time__
+
+    # increment or decrement as necessary
+    aux.step += 1
+
+    # parse out the step
+    if isinstance(step, tuple):
+        time = step[0]
+        step = step[1]
+
+    # if it's a string, do it as an action. Otherwise, assume it is a function
+    # and call it with ch as the only argument
+    if isinstance(step, str):
+        ch.act(step)
+    else:
+        step(ch)
+
+    # figure out if we need to repeat it
+    if aux.step == len(aux.routine) and aux.repeat == True:
+        aux.step = 0
+
+    # see if we need to queue up another event
+    if aux.step < len(aux.routine):
+        start_routine(ch)
+    else:
+        set_routine(ch, None)
+
+def try_step(ch):
+    '''Checks to see if we can perform a step in the routine. Returns true or
+       false if it did or not'''
+    aux = ch.getAuxiliary("routine_data")
+
+    if aux.routine == None:
+        return False
+
+    # build a list of the checks we need to perform
+    checks = __global_routine_checks__
+    if aux.checks != None:
+        checks = checks + aux.checks
+
+    # If we have checks, run them
+    if checks != None:
+        for check in checks:
+            if check(ch) == True:
+                # queue us back up to try again later
+                start_routine(ch)
+                return False
+
+    # If we had no checks or they were all passed, do the step
+    do_step(ch)
+    return True
+
+
+
+################################################################################
+# events
+################################################################################
+def routine_event(owner, data, arg):
+    '''this is the event that perpetuates NPC routines. Each NPC that has a
+       routine running has one of these events tied to him or her. When the
+       routine time expires, a check is made to see if the routine can go on.
+       If it can, the routine step is performed and the step number is
+       incremented'''
+    try_step(owner)
+
+
+    
+################################################################################
+# commands
+################################################################################
+def cmd_routine(ch, cmd, arg):
+    '''Appends a routine onto a character. The second argument needs to be an
+       evaluable list statement. Put it in parentheses to avoid being cut off
+       as spaces, since parse treats it as a single word
+
+       e.g., routine man "[\'say hi\', (3, \'say I am a little teapot\')]" True
+
+       this will say hi after the default delay, and I am a little teapot after
+       a delay of 3. It will then loop through this process indefinitely.
+       Alternatively, these commands can be replaced with function calls.
+       '''
+    try:
+        tgt, routine, repeat = parse_args(ch, True, cmd, arg,
+                                          "ch.room.noself word | bool")
+    except:
+        return
+
+    set_routine(tgt, eval(routine), repeat)
+    ch.send("Routine set.")
+
+
+
+################################################################################
+# initialization
+################################################################################
+
+# auxiliary data
+auxiliary.install("routine_data", RoutineAuxData, "character")
+
+# base check. Don't do a routine if we're currently doing an action
+register_routine_check(lambda ch: ch.isActing())
+
+# commands
+add_cmd("routine", None, cmd_routine, "sitting", "flying", "admin",
+        False, False)
+
+# misc initialization
+mud.set_routine = set_routine
